# Trait crypto::mac::Mac [−] [src]

    pub trait Mac {
        fn input(&mut self, data: &[u8]);
        fn reset(&mut self);
        fn result(&mut self) -> MacResult;
        fn raw_result(&mut self, output: &mut [u8]);
        fn output_bytes(&self) -> usize;
    }

The Mac trait defines methods for a Message Authentication function.

## Required Methods

### `fn input(&mut self, data: &[u8])`

Process input data.

# Arguments

- data - The input data to process.

### `fn reset(&mut self)`

Reset the Mac state to begin processing another input stream.

### `fn result(&mut self) -> MacResult`

Obtain the result of a Mac computation as a MacResult.

### `fn raw_result(&mut self, output: &mut [u8])`

Obtain the result of a Mac computation as [u8]. This method should be used very carefully since incorrect use of the Mac code could result in permitting a timing attack which defeats the security provided by a Mac function.

### `fn output_bytes(&self) -> usize`

Get the size of the Mac code, in bytes.

## Implementors

- `impl Mac for Blake2b`
- `impl Mac for Blake2s`
- `impl Mac for Ghash`
- `impl<D: Digest> Mac for Hmac<D>`
- `impl Mac for Poly1305`

# Help

## Keyboard Shortcuts

?
  Show this help dialog
S
  Focus the search field
⇤
  Move up in search results
⇥
  Move down in search results
⏎
  Go to active search result
+
  Collapse/expand all sections

## Search Tricks

Prefix searches with a type followed by a colon (e.g. `fn:`) to restrict the search to a given type.

Accepted types are: `fn`, `mod`, `struct`, `enum`, `trait`, `type`, `macro`, and `const`.

Search functions by type signature (e.g. `vec -> usize` or `* -> vec`)